/*=============================================================================
Vitalnix User Management Suite
cgi/sh_auth.c - Authentication methods
  Copyright © Jan Engelhardt <jengelh [at] linux01 gwdg de>, 2003 - 2005
  -- License restrictions apply (LGPL v2)

  This file is part of Vitalnix.
  Vitalnix is free software; you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published
  by the Free Software Foundation; however ONLY version 2 of the License.

  Vitalnix is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program kit; if not, write to:
  Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
  02111-1307, USA.

  -- For details see the LICENSE file
=============================================================================*/
#include <crypt.h>
#include <shadow.h>
#include <string.h>
#include "cgi/sh_auth.h"

//-----------------------------------------------------------------------------
int authenticate(const char *user, const char *in_pass) {
    struct spwd *passwd;
    char wk_salt[64], wk_pass[128];
    int rv;

    if(!(passwd = getspnam(user))) { return 0; }
    strncpy(wk_salt, passwd->sp_pwdp, sizeof(wk_salt) - 1);
    strncpy(wk_pass, crypt(in_pass, wk_salt), sizeof(wk_pass) - 1);

    rv = strncmp(wk_pass, passwd->sp_pwdp, sizeof(wk_pass)) == 0;
    memset(wk_salt, '\0', sizeof(wk_salt));
    memset(wk_pass, '\0', sizeof(wk_pass));
    return rv;
}

//==[ End of file ]============================================================
