#~~syntax:makefile
#==============================================================================
# Vitalnix User Management Suite
#   Copyright © Jan Engelhardt <jengelh [at] linux01 gwdg de>, 2003 - 2005
#   -- License restrictions apply (LGPL v2)
#
#   This file is part of Vitalnix.
#   Vitalnix is free software; you can redistribute it and/or modify it
#   under the terms of the GNU Lesser General Public License as published
#   by the Free Software Foundation; however ONLY version 2 of the License.
#
#   Vitalnix is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#   General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this program kit; if not, write to:
#   Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
#   02111-1307, USA.
#
#   -- For details see the LICENSE file
#==============================================================================

Makefile: $(patsubst %.c,%.wd,$(wildcard */*.c)) \
 $(patsubst %.cpp,%.wd,$(wildcard */*.cpp));

%.wd: %.c;
	${VECHO_DEP}
	${CC} ${CFLAGS} -MM -MF $@ -MT $(@:.wd=.wo) $<;

%.wd: %.cpp;
	${VECHO_DEP}
	${CXX} ${CXXFLAGS} -MM -MF $@ -MT $(@:.wd=.wo) $<;

_DEP_FILES := $(wildcard *.wd */*.wd)
ifneq (${_DEP_FILES},)
-include ${_DEP_FILES}
endif

#==[ End of file ]=============================================================
