/*=============================================================================
Vitalnix User Management Suite
include/accdb_int.h - Private include file for ACCDB back-end modules
  Copyright © Jan Engelhardt <jengelh [at] linux01 gwdg de>, 2003 - 2005
  -- License restrictions apply (LGPL v2)

  This file is part of Vitalnix.
  Vitalnix is free software; you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published
  by the Free Software Foundation; however ONLY version 2 of the License.

  Vitalnix is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program kit; if not, write to:
  Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
  02111-1307, USA.

  -- For details see the LICENSE file
=============================================================================*/
#ifndef _ACCDB_INT_H
#define _ACCDB_INT_H 1

#ifdef __cplusplus
extern "C" {
#endif

#ifdef __cplusplus
#    define MODULE_NAME(s) extern "C" const char _module_name[] = (s)
#    define MODULE_DESC(s) extern "C" const char _module_desc[] = (s)
#    define MODULE_INFO(s) extern "C" const char _module_info[] = (s)
#else
#    define MODULE_NAME(s) const char _module_name[] = (s)
#    define MODULE_DESC(s) const char _module_desc[] = (s)
#    define MODULE_INFO(s) const char _module_info[] = (s)
#endif

extern int q_init(struct accdb_module *, const char *);
extern int q_open(struct accdb_module *);
extern int q_usertrav(struct accdb_module *, struct accdb_user *);
extern int q_userinfo(struct accdb_module *, struct accdb_user *,
 struct accdb_user *, size_t);
extern int q_useradd(struct accdb_module *, struct accdb_user *);
extern int q_usermod(struct accdb_module *, struct accdb_user *,
 struct accdb_user *);
extern int q_userdel(struct accdb_module *, struct accdb_user *);
extern int q_grouptrav(struct accdb_module *, struct accdb_group *);
extern int q_groupinfo(struct accdb_module *, struct accdb_group *,
 struct accdb_group *, size_t);
extern int q_groupadd(struct accdb_module *, struct accdb_group *);
extern int q_groupmod(struct accdb_module *, struct accdb_group *,
 struct accdb_group *);
extern int q_groupdel(struct accdb_module *, struct accdb_group *);
extern int q_close(struct accdb_module *);
extern long q_sysctl(unsigned int, ...);
extern void q_deinit(struct accdb_module *);

#ifdef __cplusplus
};
#endif

#endif // _ACCDB_INT_H

//==[ End of file ]============================================================
